<?php
/**
* @module		VJ Zoom
* @copyright	Copyright (C) 2014 vj-tools.com
* @license		GPL
*/

defined('_JEXEC') or die('Restricted access');
error_reporting(E_ERROR);
if (!defined('DS')) {
	define('DS',DIRECTORY_SEPARATOR);
}

error_reporting(E_ERROR);
jimport("joomla.plugin.plugin");

class plgContentvjzoom extends JPlugin {
	function plgContentvjzoom(&$subject, $params) {
		parent::__construct($subject, $params);
	}
	
	function onContentPrepare($context, $article, $params, $page = 0) { 
		plgContentvjzoom::onPrepareContent($article, $params, 0);
	}

	function onPrepareContent(&$article, &$params, $limitstart) {
		$regexp = "#{vjzoom*(.*?)/}#s";
		if($this->params->get("enabled","1") == "0") {
			$article->text = preg_replace($regex, "", $article->text);
		} else {
			$vjParams = array("loadJ" => 1,
			"loadScript" => "bottom",
			"tintColour" => "#333",
			"tintOpacity" => "0.4",
			"zoomWindowPosition" => "1",
			"fade" => "0",
			"easing" => "0",
			"mouseWheelZoom" => "0",
			"responsive" => "0",
			"cursor" => "default",
			"tint" => false,
			"zoomWindowWidth" => "",
			"zoomWindowHeight" => "",
			"loadingIcon" => "modules/mod_vjzoom/css/ajax-loader.gif"
			);
			
			$pluginParams = $this->getPluginParams($vjParams);
			
			if (preg_match_all($regexp, $article->text, $matches, PREG_SET_ORDER) > 0) {
				$i = 0;
				foreach ($matches as $match) {
					if(@$match) {
						$adjustedMatch = $this->adjustMatch($match[1]);
						$adjustedMatch = parse_str($adjustedMatch, $clientParams);
						$finalParams = $this->getClientParams($clientParams, $pluginParams);
						if ($i == 0) {
							$this->addResources($finalParams);
						}
						$article->text = preg_replace($regexp, $this->getZoomPluginCode($i, $finalParams, $settings), $article->text, 1);
						$i++;
						$finalParams = $pluginParams;
					}
				}
			}
		}
	}
	
	function adjustMatch($text) {
		$adjustedMatch = ltrim($text);
		$adjustedMatch = rtrim($adjustedMatch);
		$adjustedMatch = str_replace('&', '|||', $adjustedMatch);
		$adjustedMatch = str_replace(' =', '=', $adjustedMatch);
		$adjustedMatch = str_replace('= ', '=', $adjustedMatch);
		$adjustedMatch = str_replace('="', '=', $adjustedMatch);
		$adjustedMatch = str_replace('= ', '=', $adjustedMatch);
		$adjustedMatch = str_replace('" ', '"', $adjustedMatch);
		$adjustedMatch = str_replace(' "', '"', $adjustedMatch);
		$adjustedMatch = str_replace('"', '&', $adjustedMatch);
		$adjustedMatch = str_replace(' ', '+', $adjustedMatch);
		$adjustedMatch = rtrim($adjustedMatch, '&');
		return $adjustedMatch;
	}
	
	function getZoomPluginCode($id, $finalParams, $settings) {
		$document = &JFactory::getDocument();
		$moduleId = uniqid('vjzoom', false); 
		$params = $finalParams;

		$loadJ = $params['loadJ'];
		$loadScript = $params['loadScript'];
		$position = $params['position'];
		$tintColour = $params['tintColour'];
		$tintOpacity = $params['tintOpacity'];
		$zoomWindowPosition = $params['zoomWindowPosition'];
		$fade = $params['fade'];
		$easing = $params['easing'];
		$mouseWheelZoom = $params['mouseWheelZoom'];
		$responsive = $params['responsive'];
		$lensSize = $params['lensSize'];
		$cursor = $params['cursor'];
		$tint = $params['tint'];
		$zoomWindowWidth = $params['zoomWindowWidth'];
		$zoomWindowHeight = $params['zoomWindowHeight'];
		$smallImage = $params['smallImage'];
		$bigImage = $params['bigImage'];
		$title = $params['title'];
		$titleColor = $params['titleColor'];
		$loadingIcon = $params['loadingIcon'];
		
		$smallImageArray = explode (",", $smallImage);
		$bigImageArray = explode (",", $bigImage);
		
		$returnStr = '';
		
		if ($loadScript == 'bottom') {
			$returnStr .= '<script src="' . JURI::root() . 'modules/mod_vjzoom/js/script.js" type="text/javascript"></script>';
		}

		if (count ($smallImageArray) == 1 && count ($bigImageArray) == 1) {
			$returnStr .= '<img id="vjzoom' . $moduleId . '" src=' . JURI::root() . trim($smallImageArray[0]) . ' data-zoom-image="' . JURI::root() . trim($bigImageArray[0]) . '"/><script>jQuery(document).ready(function () {jQuery("#vjzoom' . $moduleId . '").elevateZoom({';
			if ($tint) {
				$returnStr .= 'tint: true,';
			}
			$returnStr .= 'tintColour: "' . $tintColour . '",';
			$returnStr .= 'tintOpacity: "' . $tintOpacity . '",';
			if ($zoomWindowPosition == 'inner' || $zoomWindowPosition == 'lens') {
				$returnStr .= 'zoomType : "' . $zoomWindowPosition . '",';
				$returnStr .= 'lensShape: "round",';
			} else {
				$returnStr .= 'zoomWindowPosition: ' . $zoomWindowPosition . ',';
			}
			if ($fade) {
				$returnStr .= 'imageCrossfade: true,';
			}
			if ($easing) {
				$returnStr .= 'easing: true,';
			}
			if ($mouseWheelZoom) {
				$returnStr .= 'scrollZoom: ' . $mouseWheelZoom . ',';
			}
			if ($responsive) {
				$returnStr .= 'responsive: true,';
			}
			if ($lensSize) {
				$returnStr .= 'lensSize: ' . $lensSize . ',';
			}
			if ($zoomWindowWidth) {
				$returnStr .= 'zoomWindowWidth: ' . $zoomWindowWidth . ',';
			}
			if ($zoomWindowHeight) {
				$returnStr .= 'zoomWindowHeight: ' . $zoomWindowHeight . ',';
			}
			if ($title) {
				$returnStr .= 'title: "' . $title . '",';
			}
			if ($titleColor) {
				$returnStr .= 'titleColor: "' . $titleColor . '",';
			}
			if ($loadingIcon) {
				$returnStr .= 'loadingIcon: "' . $loadingIcon . '",';
			}
			$returnStr .= 'cursor: "' . $cursor . '"});});</script>';
		} else {
			$returnStr .= '<img id="vjzoom' . $moduleId . '" src="' . JURI::root() . trim($smallImageArray[0]) . '" data-zoom-image="' . JURI::root() . trim($bigImageArray[0]) . '" /><div id="gallery_' . $moduleId . '">';
			for ($i = 0; $i < count($smallImageArray); $i++) {
				if ($smallImageArray[$i]) {
					$returnStr .= '<a href="#" data-image="' . JURI::root() . trim($smallImageArray[$i]) . '" data-zoom-image="' . JURI::root() . trim($bigImageArray[$i]) . '" class="elevatezoom-gallery"><img src="' . JURI::root() . trim($smallImageArray[$i]) . '" /></a>';
				}
			}
			$returnStr .= '</div>';
			$returnStr .= '<script>jQuery(document).ready(function () {jQuery("#vjzoom' . $moduleId . '").elevateZoom({';
			$returnStr .= 'gallery: "gallery_' . $moduleId . '",';
			$returnStr .= 'galleryActiveClass: "vjactive",';
			if ($tint) {
				$returnStr .= 'tint: true,';
			}
			$returnStr .= 'tintColour: "' . $tintColour . '",';
			$returnStr .= 'tintOpacity: "' . $tintOpacity . '",';
			if ($zoomWindowPosition == 'inner' || $zoomWindowPosition == 'lens') {
				$returnStr .= 'zoomType : "' . $zoomWindowPosition . '",';
				$returnStr .= 'lensShape: "round",';
			} else {
				$returnStr .= 'zoomWindowPosition: ' . $zoomWindowPosition . ',';
			}
			if ($fade) {
				$returnStr .= 'imageCrossfade: true,';
			}
			if ($easing) {
				$returnStr .= 'easing: true,';
			}
			if ($mouseWheelZoom) {
				$returnStr .= 'scrollZoom: ' . $mouseWheelZoom . ',';
			}
			if ($responsive) {
				$returnStr .= 'responsive: true,';
			}
			if ($lensSize) {
				$returnStr .= 'lensSize: ' . $lensSize . ',';
			}
			if ($zoomWindowWidth) {
				$returnStr .= 'zoomWindowWidth: ' . $zoomWindowWidth . ',';
			}
			if ($zoomWindowHeight) {
				$returnStr .= 'zoomWindowHeight: ' . $zoomWindowHeight . ',';
			}
			if ($loadingIcon) {
				$returnStr .= 'loadingIcon: "' . $loadingIcon . '",';
			}
			$returnStr .= 'cursor: "' . $cursor . '"});});</script>';
		}
		return $returnStr;
	}
	
	function addResources($settings) {
		$document = &JFactory::getDocument();
		if ($settings['loadJ'] && $settings['loadJ'] != 'false') {
		  $document->addScript(JURI::root() . 'modules/mod_vjzoom/js/jquery.js');
		}
		if ($settings['loadScript'] && $settings['loadScript'] == 'top') {
			$document->addScript(JURI::root() . 'modules/mod_vjzoom/js/script.js');
		}
		$document->addStylesheet(JURI::root() . 'modules/mod_vjzoom/css/style.css');		
	}
	
	function getPluginParams($params) {
		$pluginParams = array();
		foreach($params as $key=>$value) {
			$pluginParams[$key] = $value;
		}
		return $pluginParams;
	}
	
	function getClientParams($params, $finalParams) {
		foreach($params as $key => $value) {
			if(@isset($params[$key])) $finalParams[$key] = htmlspecialchars($params[$key], ENT_QUOTES);
		}
		return $finalParams;
	}
	
	function clearParams($params) {
		foreach($params as $key => $value) {
			$params[$key] = '';
		}
		return $params;
	}
}

?>